using FluentValidation;
using CMSMicroservice.Protobuf.Protos.UserCarts;
namespace CMSMicroservice.Protobuf.Validator.UserCarts;

public class CreateNewUserCartsRequestValidator : AbstractValidator<CreateNewUserCartsRequest>
{
    public CreateNewUserCartsRequestValidator()
    {
        RuleFor(model => model.ProductId)
            .NotNull();
        RuleFor(model => model.UserId)
            .NotNull();
        RuleFor(model => model.Count)
            .NotNull();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<CreateNewUserCartsRequest>.CreateWithOptions((CreateNewUserCartsRequest)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
